# How to Contribute

Pull requests are greatly appreciated and are what makes opensource great. Here's a quick guide:

* Fork it
* Create your feature branch (`git checkout -b my-new-feature`)
* Commit your changes (`git commit -am 'Add some feature'`)
* Push to the branch (`git push origin my-new-feature`)
* Create new Pull Request

Pester us if we don't get your Pull Requests merged in a timely fashion. :)

## How to speed the merging of pull requests

* Describe your changes in the CHANGELOG.
* Give yourself some credit in the appropriate place (usually the CHANGELOG).
* Make commits of logical units.
* Ensure your commit messages help others understand what you are doing and why.
* Check for unnecessary whitespace with `git diff --check` before committing.
* Maintain the same code style.
* Maintain the same level of test coverage or improve it.

## Additional Resources

* [General GitHub documentation](http://help.github.com/)
* [GitHub pull request documentation](http://help.github.com/send-pull-requests/)
